//+------------------------------------------------------------------+
//|                                                Bulls & Bears.mq4 |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 DeepSkyBlue
#property indicator_color2 Red
#property indicator_color3 DeepSkyBlue
#property indicator_color4 Red
#property indicator_level1 0
#property indicator_levelcolor DimGray

//
//
//
//
//

extern int BullsBearsPeriod  = 13;
extern int ThickWidth        = 4;
extern int NarrowWidth       = 2;

//
//
//
//
//

double bearsaBuffer[];
double bullsaBuffer[];
double bearsbBuffer[];
double bullsbBuffer[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,bullsaBuffer); SetIndexStyle(0,DRAW_HISTOGRAM,EMPTY,ThickWidth);
   SetIndexBuffer(1,bearsaBuffer); SetIndexStyle(1,DRAW_HISTOGRAM,EMPTY,ThickWidth);
   SetIndexBuffer(2,bullsbBuffer); SetIndexStyle(2,DRAW_HISTOGRAM,EMPTY,NarrowWidth);
   SetIndexBuffer(3,bearsbBuffer); SetIndexStyle(3,DRAW_HISTOGRAM,EMPTY,NarrowWidth);
   return(0);
}
int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int limit;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit=MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   for(int i=limit; i>=0; i--)
   {
      bullsaBuffer[i] = EMPTY_VALUE;      
      bullsbBuffer[i] = EMPTY_VALUE;      
      bearsaBuffer[i] = EMPTY_VALUE;      
      bearsbBuffer[i] = EMPTY_VALUE;      
      
      double bulls  = iBullsPower(NULL, 0, BullsBearsPeriod,PRICE_CLOSE,i);
      double bears  = iBearsPower(NULL, 0, BullsBearsPeriod,PRICE_CLOSE,i);

         if ((bulls>0 && bears<0) || (bulls<0 && bears>0))
         {
            bullsaBuffer[i] = bulls;
            bearsaBuffer[i] = bears;
            continue;
         }         
         if (bulls>0 && bears>0)
         {
            if (bulls>bears)
            {
               bullsaBuffer[i] = bulls;
               bearsbBuffer[i] = bears;
            }
            else               
            {
               bullsbBuffer[i] = bulls;
               bearsaBuffer[i] = bears;
            }
            continue;
         }         
         
         
            if (bulls<bears)
            {
               bullsaBuffer[i] = bulls;
               bearsbBuffer[i] = bears;
            }
            else               
            {
               bullsbBuffer[i] = bulls;
               bearsaBuffer[i] = bears;
            }
         
   }
   return(0);
}

